con
  _xinfreq = 10_000_000
  _clkmode = xtal2 + pll8x

obj
  vga: "VGA_HiRes_Text"
  kbd: "keyboard_iso_010"
  mouse: "mouse_iso_010"

var
  byte screen[5000]
  byte buffer[4508]
  word color[50]
  byte cur1[3], cur2[3]
  long sync
  byte s1
  long stack1[20]
  long stack2[20]
  long stack3[20]
  long stack4[20]
  
pub main | key, v, mx, my, sx, sy
  bytefill(@screen[0], " ", 5000)
  wordfill(@color[0], %%00103330, 50)
  bytefill(@screen[100], 35, 100)
  bytefill(@screen[4800], 35, 100)
  bytemove(@screen[0], @title, strsize(@title))
  bytemove(@screen[4900], @footer, strsize(@footer))
  repeat v from 200 to 4700 step 100
    screen[v] := 35
    screen[99 + v] := 35
  cur2[0] := 1
  cur2[1] := 2
  cur2[2] := 1 
  vga.start(16, @screen[0], @color[0], @cur1[0], @sync)
  mouse.start(2)
  repeat
    mx := mx + mouse.delta_x
    my := my - mouse.delta_y
    if mx < 4
      mx := 4
    if mx > 392
      mx := 392
    if my < 8
      my := 8
    if my > 188
      my := 188
    sx := mx >> 2
    sy := my >> 2
    cur2[0] := sx
    cur2[1] := sy
    if (mouse.buttons & 1)
      screen[sx + (sy * 100)] := "*"
    if (mouse.buttons & 2)
      screen[sx + (sy * 100)] := " "
    if (mouse.buttons & 4)
      repeat while (mouse.buttons & 4)
      cur2[2] := 0
      newgen
      cur2[2] := 1
      repeat while (mouse.buttons & 4)
      mouse.delta_reset
    
pub newgen | v, w, x, y, sy, by, c
repeat while not (mouse.buttons & 4)
  bytefill(@buffer[0], " ", 4508)
  sy := 200
  by := 0 
  repeat y from 0 to 45
    repeat x from 0 to 97
      v := (x + 1) + sy 
      w := screen[v - 1] + screen[v + 1] +  screen[v - 99] +  screen[v - 100] +  screen[v - 101] +  screen[v + 99] +  screen[v + 100] +  screen[v + 101]
      if (w == 276 and (screen[v] == "*")) or (w == 286)
        buffer[x + by] := "*" 
    sy += 100
    by += 98
  v := 0
  repeat w from 201 to 4701 step 100
    bytemove(@screen[w], @buffer[v], 98)
    v := v + 98

dat
        
title   byte  "===================== John Conway's Game of Life. Hydra version by Spork Frog. =====================", 0
footer  byte  "     Left click: Fill cell      Right click: Empty cell      Middle click: Begin/end simulation     ", 0   